package test;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.pdfbox.exceptions.COSVisitorException;
import org.apache.pdfbox.io.RandomAccess;
import org.apache.pdfbox.io.RandomAccessFile;
import org.apache.pdfbox.pdfparser.PDFParser;
import org.apache.pdfbox.pdfwriter.COSWriter;
import org.apache.pdfbox.pdmodel.PDDocument;
import org.apache.pdfbox.pdmodel.PDPage;
import org.jpedal.PdfDecoder;
import org.jpedal.constants.JPedalSettings;

public class Spliter {	
	
	/**
	 * @param args
	 */
	public static void main(final String[] args) {
		// TODO Auto-generated method stub
		File fileTocut = new File(".\\src\\test\\files\\Default_Table_Formatting-merged.pdf");
		//File fileTocut = new File("F:\\4_Utilisateurs\\IHI\\20100622-Echec Decoupage\\40 paqm.pdf");
		File targetFolder = new File(".\\output");
		try {
			Spliter.splitInTwoParts(fileTocut, 2300, targetFolder);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Cut a file in two parts
	 * @param fileToCut
	 * @param SecondPartFirstPage
	 * @throws IOException 
	 */
	@SuppressWarnings("unused")
	public static void splitInTwoParts(final File fileToCut, final Integer SecondPartFirstPage, final File TargetFolder) throws IOException {
		FileInputStream fileInputStream;
		FileOutputStream fileOutputStream;
		BufferedInputStream bufferedInputStream;
        BufferedOutputStream BufferedOutputStreamoutFile;
		Boolean hasTempFile;
        PDPage currentPDPage = null;
        PdfDecoder decoder = null;
        RandomAccess tempRandomAccessFile = null;
        PDDocument document = new PDDocument();
        COSWriter  writer = null;
        PDDocument  bufferDocument = null;
        Integer numberOfPages = null;
        List<PDPage> pdPageList = null;
	    int currentPage; 
        File file = new File(fileToCut.getAbsolutePath() + ".bk");
        
        // check document's number of pages and page list.
    	hasTempFile = file.createNewFile();
    	file.createNewFile();
    	tempRandomAccessFile = new RandomAccessFile(file, "rw");
    	fileInputStream = new FileInputStream(fileToCut);
    	bufferedInputStream = new BufferedInputStream(fileInputStream);
    	PDFParser  parser = new PDFParser(bufferedInputStream, tempRandomAccessFile);
		try {
        	parser.parse();
        	document = parser.getPDDocument(); 

		    pdPageList = document.getDocumentCatalog().getAllPages();
		    numberOfPages = document.getNumberOfPages();
		}catch (Exception e){
			outLog(e.getLocalizedMessage());
        } 
        
       	File fileResult = new File(TargetFolder, "firstPart.pdf");
       	if (!fileResult.exists()) {
       		fileResult.createNewFile();
       	}    

       	fileOutputStream = new FileOutputStream(fileResult);
       	BufferedOutputStreamoutFile = new BufferedOutputStream(fileOutputStream);
       	try {
        	decoder = new PdfDecoder();
	        writer = new COSWriter(BufferedOutputStreamoutFile);
	        bufferDocument = new PDDocument();
	        
	        Map mapValues = new HashMap();
	        //do not scale above this figure
	        mapValues.put(JPedalSettings.EXTRACT_AT_BEST_QUALITY, true);
	        PdfDecoder.modifyJPedalParameters(mapValues);
	
	    	decoder.openPdfFile(fileToCut.getAbsolutePath());
	    	
	    	for (currentPage = 0; currentPage < numberOfPages; currentPage++) {
	        	//ajout de la page courante dans le documentBuffer
	        	currentPDPage = pdPageList.get(currentPage);
	        	bufferDocument.addPage(currentPDPage);
	    		
	        	if (currentPage + 1 < numberOfPages && currentPage + 2 == SecondPartFirstPage) {
	        		
		    		// ecrire le contenu du buffer dans le fichier et crer un nouveau fichier
		    		try {
						writer.write(bufferDocument);
					} catch (COSVisitorException e) {
						outLog("erreur ecriture contenu du fichier : " + fileResult.getName() + e.getMessage());
					} finally {
				       	BufferedOutputStreamoutFile.close();
				       	writer.close();
			       		bufferDocument.close();
				       	fileOutputStream.close();
					}

					
			       	fileResult = new File(TargetFolder, "secondPart.pdf");
			       	if (!fileResult.exists()) {
			       		fileResult.createNewFile();
			       	}    
			       	
			       	fileOutputStream = new FileOutputStream(fileResult);
			       	BufferedOutputStreamoutFile = new BufferedOutputStream(fileOutputStream);
			        writer = new COSWriter(BufferedOutputStreamoutFile);
			        
	                //cration d'un document buffer
	                bufferDocument = new PDDocument();
	        	} else if (currentPage + 1 == numberOfPages ) {
					// ecrire le contenu du buffer dans le fichier
		    		try {
						writer.write(bufferDocument);
					} catch (COSVisitorException e) {
						outLog("erreur ecriture contenu du fichier : " + fileResult.getName());
		    		} 
				}
	    	}
       	} catch (Exception e) {
			outLog(e.getLocalizedMessage());
       	} finally {
       		writer.close();
       		bufferDocument.close();
       		fileOutputStream.close();
        	document.close();
        	bufferedInputStream.close();
        	fileInputStream.close();
        	tempRandomAccessFile.close();
       	}        
       	
       	if (hasTempFile) {
       		file.delete();
       	}
	}
	
	private static void outLog(final String outText) {
		System.out.println(outText);
	}
	
}
